#include "ALexical.h"
#include <string.h>
#include <stdlib.h>
#include<sstream>
#include<fstream> 
#include<iostream>
#include<iomanip>
ALexical::ALexical(char* src) 
{
	aff=false;
rang_lexemes=0;
strcpy_s(source,400,src);
load_pred();
	load_ter();	
    load_lex();
}

ALexical::~ALexical(void)
{
}

void ALexical::afficherTableSymbole(){
	cout << "La table de symboles genere est :"<<endl;
	cout << " Type  |  Nom Identifiant "<<endl;
	cout << table_analyse_string.size() << endl;
	for(int unsigned i=0;i<table_analyse.size();i++){
		
		printf("%7s  %s\n", terminale[  table_analyse[i].type + 2],table_analyse[i].nom);
	}

}
void ALexical::afficherTokens(){
	cout << "Les tokens reconnue sont " <<endl;
	for (int i = 0; i<tokens.size();i++) 
	{	cout<<"< "<<tokens[i]<<" > " << endl;}

}
void ALexical::load_ter()
{
	string temp;
	ifstream fileIn("grammaire.txt");
	fileIn >> temp;
	fileIn >> temp;
	   while(temp != "nonterminal")
		{
			terminale.push_back(temp);
			fileIn >> temp;
			
		}
	  LEXICAL_MARQ_FIN = 1;
	   for(unsigned int i=0;i<terminale.size();i++)
	   {
               if (terminale[i] == "id") 
LEXICAL_IDENT = i+2;
			   if (terminale[i] == "+") 
 LEXICAL_PLUS = i+2;
		       if (terminale[i] == "++")
 LEXICAL_PLUS_PLUS = i+2;
		       if (terminale[i] == "-") 
 LEXICAL_MOINS =i+2;
		       if (terminale[i] == "--")
 LEXICAL_MOINS_MOINS = i+2 ;
		       if (terminale[i] == "(")
 LEXICAL_PAR_OUVERT =  i+2;
		       if (terminale[i] == ")")
 LEXICAL_PAR_FERMANT =  i+2;
		       if (terminale[i] == "{")
 LEXICAL_ACLD_OUVRERT =  i+2;
		       if (terminale[i] == "}") 
 LEXICAL_ACLD_FERMANT =  i+2;
			if (terminale[i] == "<")
 LEXICAL_INF =  i+2;
		       if (terminale[i] == "<=")
 LEXICAL_INF_EGALE =  i+2;
			if (terminale[i] == ">")
 LEXICAL_SUP =  i+2;
		       if (terminale[i] == ">=")
 LEXICAL_SUP_EGALE =  i+2;
		       if (terminale[i] == "=")
 LEXICAL_EGALE =  i+2;
		        if (terminale[i] == "==")
 LEXICAL_EGALE_EGALE =  i+2;
		        if (terminale[i] == ";;")
LEXICAL_POINT_VERGULE =  i+2;
				    if (terminale[i] == ",")
LEXICAL_VERGULE =  i+2;
			   if (terminale[i] == "||")
 LEXICAL_OU =  i+2;
			   if (terminale[i] == "&")
 LEXICAL_AND =  i+2;
			   if (terminale[i] == "&&")
 LEXICAL_AND_AND =  i+2;
		       if (terminale[i] == "!=")
 LEXICAL_DIFF =  i+2;
			   if (terminale[i] == "!") 
 LEXICAL_NOT =  i+2;
			   if (terminale[i] == "[") 
 LEXICAL_CRO_OUVERT =  i+2;
			  if (terminale[i] == "]")
 LEXICAL_CRO_FERMANT =  i+2;
		      if (terminale[i] == "*") 
 LEXICAL_FOIS =  i+2;
		       if (terminale[i] == "/") 
 LEXICAL_DIV =  i+2;
		       if (terminale[i] == "%")
 LEXICAL_MOD =  i+2;
			   if (terminale[i] == ":")
 LEXICAL_COND =  i+2;
			   if (terminale[i] == "int") 
LEXICAL_INT = i+2;
		   if (terminale[i] == "double") 
 LEXICAL_DOUBLE = i+2;
		   if (terminale[i] == "char") 
 LEXICAL_CHAR = i+2;
		   	   if (terminale[i] == "char*") 
 LEXICAL_CHAINE_CARACTERE = i+2;
		   if (terminale[i] == "float") 
 LEXICAL_FLOAT = i+2;
		   if (terminale[i] == "long") 
 LEXICAL_LONG = i+2;
		   if (terminale[i] == "short") 
 LEXICAL_SHORT = i+2;
		   if (terminale[i] == "void") 
 LEXICAL_VOID = i+2;
		   if (terminale[i] == "main") 
 LEXICAL_MAIN = i+2;
			   if (terminale[i] == "break") 
 LEXICAL_BREAK = i+2;
			   if (terminale[i] == "case") 
 LEXICAL_CASE = i+2;
			   if (terminale[i] == "continue") 
LEXICAL_CONTINUE = i+2;
			   if (terminale[i] == "default") 
 LEXICAL_DEFAULT = i+2;
			   if (terminale[i] == "do") 
 LEXICAL_DO = i+2;
			   if (terminale[i] == "else") 
 LEXICAL_ELSE = i+2;
					if (terminale[i] == "enum") 
 LEXICAL_ENUM = i+2;
					if (terminale[i] == "for") 
LEXICAL_FOR = i+2;
					if (terminale[i] == "if") 
 LEXICAL_IF = i+2;
					if (terminale[i] == "return") 
 LEXICAL_RETURN = i+2;
					if (terminale[i] == "sizeof") 
 LEXICAL_SIZEOF = i+2;
					if (terminale[i] == "struct") 
 LEXICAL_STRUCT = i+2;
					if (terminale[i] == "switch") 
 LEXICAL_SWITCH = i+2;
					if (terminale[i] == "union") 
 LEXICAL_UNION = i+2;
					if (terminale[i] == "typedef") 
 LEXICAL_TYPEDEF = i+2;
					if (terminale[i] == "while") 
 LEXICAL_WHILE = i+2;
					if (terminale[i] == "type_int") 
						LEXICAL_TYPE_INT= i+2;
					if (terminale[i] == "type_char*") 
						LEXICAL_TYPE_CHAINE = i+2;
					if (terminale[i] == "type_double") 
						LEXICAL_TYPE_DOUBLE = i+2;
					if (terminale[i] == "type_float") 
						LEXICAL_TYPE_FLOAT = i+2;
					if (terminale[i] == "type_char") 
						LEXICAL_TYPE_CHAR = i+2;
					if (terminale[i] == "type_short") 
						LEXICAL_TYPE_SHORT = i+2;
					if (terminale[i] == "type_long") 
						LEXICAL_TYPE_LONG = i+2;
	   }
}


void ALexical::load_pred()
{      
		string temp;
		ifstream fileIn("type.txt");
		
		
		fileIn >> temp;
	    if(temp != "type_var")
		{
			//cout<< "Erreur dans la fichier type, elle doit commencer par 'type_var'"<<endl;
		    exit(1);
		}
	   
		fileIn >> temp;
	    while(temp != ";")
		{
			type_var.push_back(temp);
			fileIn >> temp;
			
		}
		fileIn >> temp;
	
	    if(temp !="predefine"){
			//cout<< "Erreur dans la fichier type, elle doit commencer par 'predefine'"<<endl;
		    exit(2);
							}


		fileIn >> temp;
		while(temp != ";"){
			predefine.push_back(temp);
			fileIn >> temp;
		}


		
}




void ALexical::load_lex()
{
	
	    string temp,chaine;
		//tokens.push_back("$");
		ifstream fileIn(source);
		bool sub;
	    
		while(! fileIn.eof())
		{
			fileIn >> temp;
			
			
			sub=true;
			while(sub)
			{

			for(unsigned int i=0;i<=temp.size();i++)
			{   
				if(temp[i]=='+')
				{
					if(temp[i+1]=='+')
					{
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("++");
						temp=temp.substr(i+2, temp.size());
						i=-1;
					}
					else
					{
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("+");
						temp=temp.substr(i+1, temp.size());
						i=-1;
					}
				}
				else if(temp[i]=='-')
				{
					if(temp[i+1]=='-')
					{
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("--");
						temp=temp.substr(i+2, temp.size());
						i=-1;
					}
					else
					{
						
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("-");
						temp=temp.substr(i+1, temp.size());
						i=-1;
						
					}
				}
				else if(temp[i]=='=')
				{
					if(temp[i+1]=='=')
					{
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("==");
						temp=temp.substr(i+2, temp.size());
						i=-1;
					}
					else
					{
						
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("=");
						temp=temp.substr(i+1, temp.size());
						i=-1;
						
					}
				}
				else if(temp[i]=='<')
				{
					if(temp[i+1]=='=')
					{
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("<=");
						temp=temp.substr(i+2, temp.size());
						i=-1;
					}
					else
					{
						
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("<");
						temp=temp.substr(i+1, temp.size());
						i=-1;
						
					}
				}
				else if(temp[i]=='>')
				{
					if(temp[i+1]=='=')
					{
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back(">=");
						temp=temp.substr(i+2, temp.size());
						i=-1;
					}
					else
					{
						
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back(">");
						temp=temp.substr(i+1, temp.size());
						i=-1;
						
					}
				}
				else if(temp[i]=='!')
				{
					if(temp[i+1]=='=')
					{	
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("!=");
						temp=temp.substr(i+2, temp.size());
						i=-1;
						
					}
					else
					{
						
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("!");
						temp=temp.substr(i+1, temp.size());
						i=-1;
						
					}
				}	
				
				else if(temp[i]=='&')
				{
					if(temp[i+1]=='&&')
					{	
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("&&");
						temp=temp.substr(i+2, temp.size());
						i=-1;
						
					}
					else
					{
						
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("&");
						temp=temp.substr(i+1, temp.size()+1);
						i=-1;
						
					}
				}	//s1.assign(p+2, p+6);
				else if(temp[i]=='*')
				{
					string chaine;
						chaine=temp.substr(0, i);
						  lexemes.push_back(chaine);
						  lexemes.push_back("*");
						  temp=temp.substr(i+1, temp.size());
							i=-1;
				}
				
				else if(temp[i] == '(')
				{
						string chaine;
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back("(");
						temp=temp.substr(i+1, temp.size());
						i=-1;
				}
				else if(temp[i] == ',')
				{
						string chaine;
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back(",");
						temp=temp.substr(i+1, temp.size());
						i=-1;
				}
				else if(temp[i] == ';')
				{
						string chaine;
						chaine=temp.substr(0, i);
						lexemes.push_back(chaine);
						lexemes.push_back(";;");
						temp=temp.substr(i+1, temp.size());
						i=-1;
				}
				else if(temp[i]==')')
				{
					string chaine;
						chaine=temp.substr(0, i);
						  lexemes.push_back(chaine);
						  lexemes.push_back(")");
						  temp=temp.substr(i+1, temp.size());
							i=-1;
				}else if(temp[i]=='}')
				{
					string chaine;
						chaine=temp.substr(0, i);
						  lexemes.push_back(chaine);
						  lexemes.push_back("}");
						  temp=temp.substr(i+1, temp.size());
							i=-1;
				}
				else if(temp[i]=='{')
				{
					string chaine;
						chaine=temp.substr(0, i);
						  lexemes.push_back(chaine);
						  lexemes.push_back("{");
						  temp=temp.substr(i+1, temp.size());
							i=-1;
				}
				else if(temp[i]=='[')
				{
					string chaine;
						chaine=temp.substr(0, i);
						  lexemes.push_back(chaine);
						  lexemes.push_back("[");
						  temp=temp.substr(i+1, temp.size());
							i=-1;
				}
				else if(temp[i]==']')
				{
					string chaine;
						chaine=temp.substr(0, i);
						  lexemes.push_back(chaine);
						  lexemes.push_back("]");
						  temp=temp.substr(i+1, temp.size());
							i=-1;
				}
				else if(temp[i]==';')
				{
					string chaine;
						chaine=temp.substr(0, i);
						  lexemes.push_back(chaine);
						  lexemes.push_back(";");
						  temp=temp.substr(i+1, temp.size());
									i=-1;
				}
				

				else
				{
					 
					sub=false;

				}
			}
			}
			lexemes.push_back(temp);
			
	 }
	   for(unsigned int i=0;i<lexemes.size();++i)
	   {
		   if((lexemes[i] != "")){
			   tokens.push_back(lexemes[i]);
			   
		   }
	   }


	   
	   
	   
	   
	   //cout <<"les lexemes sont les suivant"<<endl;
	  /* for(int i=0;i<tokens.size();++i)
	   {
		   //cout<<tokens[i]<<endl;
	   }
*/
}



Information ALexical::voirSuivant(){
  aff=false;
	Information info  ;
	info.etat=-1;
	info.type=-1;
	info.type_var=-1;
	info.valeur.Chaine=NULL;
	info.valeur.Entier=-1;
	info.valeur.Double=-1;
	
	 
	info=getSuivant();
	if(rang_lexemes)rang_lexemes--;
	aff=false;
	return info;


	
/*	switch(i){
		 case 1:t=1; info.valeur.Entier = 4;info.type = ALexical::LEXICAL_NOMBRE;
		 break;
		 case 2:t=2;info.valeur.Entier = 9;info.type = ALexical::LEXICAL_PLUS;
		 break;
		 case 3:t=1; info.valeur.Entier = 8;info.type = ALexical::LEXICAL_NOMBRE;
		 break;
		 case 4:t=3;info.valeur.Entier = 7;	info.type = ALexical::LEXICAL_FOIS;
		 break;
		 case 5:t=1; info.valeur.Entier = 3;info.type = ALexical::LEXICAL_NOMBRE;
		 break;
		 case 6:info.type = ALexical::LEXICAL_FINFICHIER;
			  t= LEXICAL_FINFICHIER ;
	}*/

	return info;
}











Information ALexical::getSuivant()
{
	//cout<<tokens[rang_lexemes]<<endl;
	Information info  ;
	info.etat=-1;
	info.type=-1;
	info.type_var=-1;
	info.valeur.Chaine=NULL;
	info.valeur.Entier=-1;
	info.valeur.Double=-1;

	if((unsigned )rang_lexemes < tokens.size())
	{
	                               	if(in(tokens[rang_lexemes],type_var))
		                            {
										info.valeur.Chaine=(char *)(tokens[rang_lexemes].c_str());
			
													if(   ! strcmp(info.valeur.Chaine ,"int"))
														info.type=LEXICAL_TYPE_INT ;
		
													else if(! strcmp(info.valeur.Chaine,"double"))
															info.type=LEXICAL_TYPE_DOUBLE;
													else if( !strcmp(info.valeur.Chaine,"char"))
														info.type=LEXICAL_TYPE_CHAR;
													else if(!strcmp(info.valeur.Chaine,"float"))
														info.type=LEXICAL_TYPE_FLOAT;
													else if(!strcmp(info.valeur.Chaine,"long"))
														info.type=LEXICAL_TYPE_LONG;
													else if( ! strcmp(info.valeur.Chaine,"short"))
														info.type=LEXICAL_TYPE_SHORT;
													else if( ! strcmp(info.valeur.Chaine,"void"))
															info.type=LEXICAL_VOID;
											//cout<<info.valeur.Chaine<<"--->"<<info.type_var<<"-->"<<info.type<<endl;
											rang_lexemes++;
											if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
											return info;
									}
									
									else if(in(tokens[rang_lexemes],predefine))
									{
											info.valeur.Chaine=(char *)(tokens[rang_lexemes].c_str());
		
											if(!strcmp(info.valeur.Chaine,"main"))
											info.type=LEXICAL_MAIN;
											if(!strcmp(info.valeur.Chaine,"break"))
											info.type=LEXICAL_BREAK;
											if(!strcmp(info.valeur.Chaine,"case"))
											info.type=LEXICAL_CASE;
											if( ! strcmp(info.valeur.Chaine,"continue"))
											info.type=LEXICAL_CONTINUE;
											if( ! strcmp(info.valeur.Chaine,"default"))
											info.type=LEXICAL_DEFAULT;
											if(!strcmp(info.valeur.Chaine,"do"))
											info.type=LEXICAL_DO;
											if(!strcmp(info.valeur.Chaine,"else"))
											info.type=LEXICAL_ELSE;
											if(! strcmp(info.valeur.Chaine,"enum"))
											info.type=LEXICAL_ENUM;
											if(!strcmp( info.valeur.Chaine,"for"))
											info.type=LEXICAL_FOR;
											if(!strcmp(info.valeur.Chaine,"if"))
											info.type=LEXICAL_IF;
											if(!strcmp(info.valeur.Chaine,"return"))
											info.type=LEXICAL_RETURN;
											if(! strcmp(info.valeur.Chaine,"sizeof"))
											info.type=LEXICAL_SIZEOF;
											if(!strcmp(info.valeur.Chaine,"struct"))
											info.type=LEXICAL_STRUCT;
											if(!strcmp(info.valeur.Chaine,"switch"))
											info.type=LEXICAL_SWITCH;
											if(! strcmp(info.valeur.Chaine,"union"))
											info.type=LEXICAL_UNION;
											if(!strcmp(info.valeur.Chaine,"typedef"))
											info.type=LEXICAL_TYPEDEF;
											if(!strcmp(info.valeur.Chaine,"while"))
											info.type=LEXICAL_WHILE;
		
											//cout<<info.valeur.Chaine<<"-->"<<info.type_var<<"-->"<<info.type<<endl;
											rang_lexemes++;
											if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
											return info;
									}
									
									else if(in(tokens[rang_lexemes],terminale)&&(tokens[rang_lexemes]!="id"))
									{
											info.valeur.Chaine=(char *)(tokens[rang_lexemes].c_str());
			
											if ( ! strcmp(info.valeur.Chaine , "+")) 
											info.type = LEXICAL_PLUS;
											else if (! strcmp (info.valeur.Chaine , "++"))
											info.type =LEXICAL_PLUS_PLUS ;
											else if (! strcmp(info.valeur.Chaine , "-") )
											info.type =LEXICAL_MOINS ;
											else if (! strcmp(info.valeur.Chaine , "--") )
											info.type = LEXICAL_MOINS_MOINS  ;
											else if (! strcmp(info.valeur.Chaine , "(") )
											info.type = LEXICAL_PAR_OUVERT ;
											else if (! strcmp(info.valeur.Chaine , ")"))
											info.type = LEXICAL_PAR_FERMANT ;
											else   if (! strcmp(info.valeur.Chaine , "{"))
											info.type =LEXICAL_ACLD_OUVRERT ;
											else  if (! strcmp(info.valeur.Chaine , "}")) 
											info.type = LEXICAL_ACLD_FERMANT ;
											else if (!strcmp(info.valeur.Chaine , "<"))
											info.type =LEXICAL_INF ;
											else if (!strcmp (info.valeur.Chaine , "<="))
											info.type =LEXICAL_INF_EGALE ;
											else if (!strcmp (info.valeur.Chaine , ">"))
											info.type =LEXICAL_SUP ;
											else if (!strcmp(info.valeur.Chaine , ">="))
											info.type = LEXICAL_SUP_EGALE ;
											else   if (!strcmp(info.valeur.Chaine , "="))
											info.type = LEXICAL_EGALE ;
											else    if (!strcmp(info.valeur.Chaine , "=="))
											info.type = LEXICAL_EGALE_EGALE ;
											else   if (!strcmp(info.valeur.Chaine , ";;"))
											info.type = LEXICAL_POINT_VERGULE ;
											else   if (!strcmp(info.valeur.Chaine , ","))
											info.type = LEXICAL_VERGULE ;
											else  if (!strcmp(info.valeur.Chaine , "||"))
											info.type = LEXICAL_OU ;
											else  if (!strcmp(info.valeur.Chaine , "&"))
											info.type =LEXICAL_AND ;
											else   if (!strcmp(info.valeur.Chaine , "&&"))
											info.type =LEXICAL_AND_AND ;
											else  if (!strcmp(info.valeur.Chaine , "!="))
											info.type =LEXICAL_DIFF ;
											else  if (!strcmp(info.valeur.Chaine , "!") )
											info.type =LEXICAL_NOT ;
											else   if (!strcmp(info.valeur.Chaine , "[") )
											info.type = LEXICAL_CRO_OUVERT ;
											else  if (!strcmp(info.valeur.Chaine , "]"))
											info.type =LEXICAL_CRO_FERMANT ;
											else  if (!strcmp(info.valeur.Chaine , "*") )
											info.type =LEXICAL_FOIS ;
											else  if (!strcmp(info.valeur.Chaine , "/") )
											info.type =LEXICAL_DIV ;
											else if (!strcmp(info.valeur.Chaine , "%"))
											info.type =LEXICAL_MOD;
											else if (!strcmp(info.valeur.Chaine , ":"))
											info.type =LEXICAL_COND;
											if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
									
			
											//cout<<info.valeur.Chaine<<"-->"<<info.type_var<<"-->"<<info.type<<endl;
											rang_lexemes++;
											return info;
								  }		


		                         else if(est_entier( tokens[rang_lexemes]))
								      {
										info.valeur.Entier = atoi(tokens[rang_lexemes].c_str());
										info.type = LEXICAL_INT;
										//info.type_var=LEXICAL_INT;
									//	//cout<<info.valeur.Entier<<"-->"<<info.type<<"-->"<<info.type_var<<endl;
										rang_lexemes++;
										if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
									
										return info;
									  }
	
								 else if(est_double(tokens[rang_lexemes]))
		
								 {
								    info.valeur.Double = atof(tokens[rang_lexemes].c_str());
									info.type = LEXICAL_DOUBLE;
									//info.type_var=LEXICAL_DOUBLE;
									////cout<<info.valeur.Double<<"-->"<<info.type<<"-->"<<info.type_var<<endl;
									rang_lexemes++;
									if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
									return info;
								 }
								 else if(est_float(tokens[rang_lexemes]))
		
								 {
								    info.valeur.Double = atol(tokens[rang_lexemes].c_str());
									info.type = LEXICAL_FLOAT;
									//info.type_var=LEXICAL_DOUBLE;
									////cout<<info.valeur.Double<<"-->"<<info.type<<"-->"<<info.type_var<<endl;
									rang_lexemes++;
									if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
									return info;
								 }
		
								 else
									{
											IDENTIFANT id;
											id.nom=NULL;
											id.type=-1;
											id.val.Chaine=NULL;
											id.val.Double=0;
											id.val.Entier=0;
			                        ////cout<<"traitement de identificcateur"<<endl;
									 info.valeur.Chaine=(char*)(tokens[rang_lexemes].c_str());
										 info.type=LEXICAL_IDENT;
										
									 id.nom= info.valeur.Chaine;

									 
									 if(!strcmp((char*)(tokens[rang_lexemes].c_str()),"int"))
									 {
										 info.type_var=LEXICAL_INT;
										 id.type=LEXICAL_INT;

									 }
									 else if(!strcmp((char*)(tokens[rang_lexemes].c_str()),"double"))
									 {
										 info.type_var=LEXICAL_DOUBLE;
										 id.type=LEXICAL_DOUBLE;
									 }
									 else if(!strcmp((char*)(tokens[rang_lexemes].c_str()),"float"))
									 {
										 info.type_var=LEXICAL_FLOAT;
										 id.type=LEXICAL_FLOAT;
									 }
									 else if(!strcmp((char*)(tokens[rang_lexemes].c_str()),"char"))
									 {
										 info.type_var=LEXICAL_CHAR;
										 id.type=LEXICAL_CHAR;
									 }
									 else if(!strcmp((char*)(tokens[rang_lexemes].c_str()),"*"))
									 {
										 if(!strcmp((char*)(tokens[rang_lexemes-1].c_str()),"char")){
											 info.type_var=LEXICAL_CHAINE_CARACTERE;
											 id.type=LEXICAL_CHAINE_CARACTERE;
											
										 }
									 }
                                       
									 if(!in(tokens[rang_lexemes],table_analyse_string))
									 {
										 table_analyse.push_back(id);
										 table_analyse_string.push_back(tokens[rang_lexemes]);
									 }
									////cout<<info.valeur.Chaine<<"-->"<<info.type<<"-->"<<info.type_var<<endl; 

									rang_lexemes++;
									if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
									 return info;		
								 }
	}
	else if(rang_lexemes==tokens.size())
	{
		info.type = LEXICAL_MARQ_FIN;
		rang_lexemes++;
		if(aff)cout << "type "<< info.type << endl << "val " << info.valeur.Entier<<endl;
		return info;
	}	
}










bool ALexical::in(string s , vector<string> v)
{
	for(unsigned int i=0;i<v.size();i++)
	{
		if (v[i]==s) return true;
	}
	return false;
}



bool ALexical::est_double (string v)
{
	bool test;
	for(unsigned int i=0;i<v.size();i++)
	{
		if (((v[i]>'0')&(v[i]<'9'))|| v[i] == '.'  ) test=true;
		else { test=false;i=v.size();}
	}
	return test;
}

bool ALexical::est_entier (string v)
{
	for(unsigned int i=0;i<v.size();i++)

	{
		
		if ((v[i]<'0')||(v[i]>'9') ) return false;
	}
	return true;
}

bool ALexical:: est_float(string v)
{
	for(unsigned int i=0;i<v.size()-1;i++)

	{
		
		if ((v[i]<'0')||(v[i]>'9')) return false;
	}
	if((v[v.size()-1]!='f')||(v[v.size()-1]!='F')) return false;
	return true;
}






void ALexical::teststring()
{
	
	string c ="34.3";
	string b ="der34";
    string d ="444" ;
	
	int dd=atoi(d.c_str());
	dd++;
	////cout <<dd;
	
	//if(est_entier(b)) //cout<<b<<"est entier"<<endl;
    //if(est_double(b)) //cout<<b<< "est double"<<endl;
    

}