#include "ASantaxique.h"
#include "ALexical.h"
#include <iostream>
#include <string.h>
#include<stdlib.h>
#include <conio.h>
using namespace std;

int main(int argc , char * argv[]){

	bool premier =false;
	bool suivant =false;
	bool tokens=false;
	bool arbre=false;
	bool gencode = false;
	bool tableanalyse=false;
	bool collectionItem=false;
	bool transitions =false;
	bool grammaire=false;
	cout << "\t+----------------------------------------------------------------+"<<endl;
	cout << "\t|        *****   ii2compiler ENSI 2009/2010  *****               |"<<endl;
	cout << "\t|          ***** Encadr par Mr Z.BOUYAHYA  *****               |"<<endl;
	cout << "\t|                    * AROURI  cyrin *                           |"<<endl;
	cout << "\t|                     * DRIDI ahmed *                            |"<<endl;
	cout << "\t|                      * HMANI rim *                             |"<<endl;
	cout << "\t|                   * KHANNOUSSI  ahmed *                        |"<<endl;
	cout << "\t|                    *  MAALMI hichem  *                         |"<<endl;
	cout << "\t|                     * MESSAADI issam *                         |"<<endl;
	cout << "\t|                     * YAHMADI ahmed *                          |"<<endl;
	cout << "\t+----------------------------------------------------------------+"<<endl;
		
		
		
				
		
		
		
	cout << "\t| Utilisation : ii2compiler source.c [-l -s -P -S -t -C -G]      |    "<<endl;
	cout << "\t| -l   Affichage des tokens                                      |    "<<endl;
	cout << "\t| -s   Affichage du trace du parseur ascendant                   |    "<<endl;
	cout << "\t| -P   Affichage des ensembles premiers                          |    "<<endl;
	cout << "\t| -g   Affichage du code intermediaire genere                    |    "<<endl;
	cout << "\t| -S   Affichage des ensembles suivants                          |    "<<endl;
	cout << "\t| -t   Affichage du table d'analyse genere                       |    "<<endl;
	cout << "\t| -C   Affichage des collections d'items genere                  |    "<<endl;
	cout << "\t| -G   Affichage du grammaire utilise                            |    "<<endl;
	cout << "\t+----------------------------------------------------------------+"<<endl;
if(argc == 1)exit(0);
		
for (int i =1;i<argc;i++)
{
	
	if(!strcmp(argv[i],"-l")){
		tokens=true;
		
		}
if(!strcmp(argv[i],"-s")){
		arbre=true;
		}if(!strcmp(argv[i],"-P")){
		premier=true;
		}if(!strcmp(argv[i],"-S")){
		suivant=true;
		}if(!strcmp(argv[i],"-t")){
		tableanalyse=true;

		}if(!strcmp(argv[i],"-T")){
		transitions=true;
		}if(!strcmp(argv[i],"-C")){
			collectionItem=true;
		}if(!strcmp(argv[i],"-G")){
		grammaire=true;;
		}
		if(!strcmp(argv[i],"-g")){
		gencode=true;

		}
	}


	//ALexical A("src.txt") ;
	//A.load_lex();
	
	
	ASantaxique san("grammaire.txt",argv[1]);
	//san.analyseurlexical.afficherTableSymbole();
	if(tokens)san.analyseurlexical.afficherTokens();
	if(grammaire)san.afficherGrammaire();
	if(premier)san.afficherPremier();
	if(suivant)san.afficherSuivant();
	if(collectionItem)san.afficherCollectionItem();
	if(transitions)san.afficherTransitions();
	
	
	if(tableanalyse)san.afficherTableAnalyse();
	
	
	
	san.activerAffichageAnalyse(arbre);
san.activerGenerationCode(gencode);
	if(san.analyser())cout<<"Compile avec success"<<endl;
	else
		cout << "Erreur lors du compilation, verifier la santaxe"<<endl;
 	
   return 0;
}	